
#include <mzlib.h>

#define PHASEDIF 6 // How much neighbors differ in phase

extern unsigned char phases[];
extern signed char sini[];

static unsigned char ptn[42];
static unsigned prekalkki[256];

static void refresh(void)
{
    _asm
    push    hl
    push    bc
    push    de

    ld      de,#0xd000

    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$

    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$

    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$

    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$

    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$
    ld      hl,#_ptn
    call    1$

    jp      2$

1$:
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi

    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi

    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi

    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi

    ret

2$: pop     de
    pop     bc
    pop     hl
    _endasm;
}

void init_blind(char col1,char col2)
{
    unsigned i;
    unsigned char n,*coltab=(unsigned char *)COLOR_TABLE;
    int lev;

    for(n=0;n<25;n++)
    {
        for(i=0;i<40;i+=6)
        {
            if(i/6&1)
                mem_set(coltab,col2,6);
            else
                mem_set(coltab,col1,6);

            coltab+=6;
            if(i==36)
                coltab-=2;
        }
    }

    for(i=0;i<256;i++)
    {
        lev=20+(sini[i&255]>>3)+(sini[(255-i)*4 &255]>>3);
        if(lev<0)
            lev=0;
        if(lev>48)
            lev=48;
        prekalkki[i]=lev*6;
    }
}

void run_blind(unsigned char phase)
{
    unsigned char n,tkohta,*patpt;
    unsigned off;

    tkohta=phase;

    patpt=ptn;
    for(n=0;n<7;n++,patpt+=6)
    {
        off=prekalkki[tkohta];
        mem_cpy(patpt,&phases[off],6);

        tkohta+=6;
    }

    refresh();
}
