
#include <mzlib.h>
#include <string.h>

#define GREETS 20
#define GCOLOR 0x07
#define YLOC (40*21)

#define DURATION 37 // Vblanks for one plaque

static char *greet[GREETS]={
    "",
    "GREETINGSIES!",
    "",

    "ARKOS",
    "BANDWAGON",
    "BYTERAPERS",
    "COMA",
    "DCS",

    "DEKADENCE",
    "DVIK & JOYREX",
    "EXTEND",
    "HALCYON",
    "HEDELMAE",

    "LIEVES!TUORE",
    "NYYRIKKI",
    "RNO",
    "TRACTION",
    "WAMMA",

    "ZENON",

    ""
};

static unsigned char phase[GREETS],
                     len[GREETS];

static unsigned char latka[]={
    0x78,0x78,0x78,0x78, 0x78,0x78,0x78,0x78, 0x78,0x78,0x78,0x78, 0x78,0x78,0x78,0x78, 0x78,0x78,0x78,0x78, 0x78,0x78,0x78,0x78, 0x78,0x78,0x78,0x78, 0x78,0x78,0x78,0x4c,
    0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0x35,
    0x34,0x34,0x34,0x34, 0x34,0x34,0x34,0x34, 0x34,0x34,0x34,0x34, 0x34,0x34,0x34,0x34, 0x34,0x34,0x34,0x34, 0x34,0x34,0x34,0x34, 0x34,0x34,0x34,0x34, 0x34,0x34,0x34,0x6e
};

static unsigned char bakkis[]={
  0x70,0x70,0x70,0x70,0x70,0x70, 0x20,0x20,0x20,0x20,0x20,0x20, 0x70,0x70,0x70,0x70,0x70,0x70
};

void init_greet(void)
{
    int n;
    for(n=0;n<GREETS;n++)
    {
        phase[n]=0;
        len[n]=strlen(greet[n]);
        ascii_string(greet[n]);
    }
}

void run_greet(int tid)
{
    unsigned char *p,l;
    static unsigned char ctr=DURATION-1,cur=255;

    if(cur==GREETS)
        return;

    ctr++;
    if(ctr==DURATION)
    {
        ctr=0;
        cur++;
        if(cur==GREETS)
            return;

        mem_cpy(&latka[63-len[cur]],greet[cur],len[cur]);
        latka[63-len[cur]-1]=0;

        p=(char *)YLOC+0xd800;
        mem_cpy(p,bakkis,18);
        mem_cpy(p+40,bakkis,18);
        mem_cpy(p+80,bakkis,18);
    }

    if(!len[cur])
        return;

    l=ctr;
    if(!l)
        return;

    if(l>len[cur]+2)
        l=len[cur]+2;

    p=(char *)YLOC+0xd800;
    mem_set(p,GCOLOR,l);
    mem_set(p+40,GCOLOR,l);
    mem_set(p+80,GCOLOR,l);

    p=(char *)YLOC+0xd000;
    mem_cpy(p,&latka[32-l],l);
    mem_cpy(p+40,&latka[64-l],l);
    mem_cpy(p+80,&latka[96-l],l);
}
