
#include <stdio.h>
#include <mzlib.h>

#define LETTERDELAY 3
#define ROWDELAY 22
#define BLINKPERIOD 10
#define XPOS 2
#define YPOS 3

//|.....     .....     .....     .....     |
static char *tegst=
  "WELL WELL, WHAT DO WE HAVE HERE?@"
  "@"
  "A SHARP MZ-721 FROM 1982 A.D.:@"
  "@"
  "- 3.5 MHZ Z80 CPU@"
  "- 64 KB RAM, 4 KB VRAM@"
  "- 40 X 25 CHARACTERS, 8 COLORS@"
  "- FIXED CHARACTER SET@"
  "- NO SCROLLING, NO SPRITES@"
  "- ONE-CHANNEL SQUARE WAVE BEEPER@"
  "@"
  "+ LOADS OF NOSTALGIA :)@"
  "@"
  "@"
  "THE FUT<<ITURE CREW IS BACK TO CELEBRATE@"
  "THEIR 20TH ANNIVERSARY WITH A DEMO@"
  "CALLED...@"
;

unsigned char blinkutes(void)
{
    static char cnt=0,cur=0;

    cnt++;
    if(cnt==BLINKPERIOD)
    {
        cnt=0;
        cur=1-cur;
    }

    if(cur)
        return(0xd0);
    else
        return(0);
}

void initscreen(void)
{
    unsigned n;
    char     c,*p=tegst,jitter;
    int     x=XPOS,y=YPOS,i;

    for(i=0;i<25;i++)
    {
        waitVB();
        mem_set((char *)CHAR_TABLE+i*40,0,40);
        mem_set((char *)COLOR_TABLE+i*40,0x70,40);
    }

    while(1)
    {
        c=*p++;
        if(c==0)
            break;

        if(c=='@')
        {
            y++;
            x=XPOS;
            for(n=0;n<ROWDELAY;n++)
            {
                waitVB();
                poke(CHAR_TABLE+x+y*40,blinkutes());
            }
            poke(CHAR_TABLE+x+y*40,0);
            continue;
        }

        if(c=='<')
        {
            x--;
            for(n=0;n<LETTERDELAY+jitter;n++)
            {
                waitVB();
                poke(CHAR_TABLE+x+y*40,blinkutes());
            }
            poke(CHAR_TABLE+x+y*40,0);
            continue;
        }

        c=ascii_char(c);

        poke(CHAR_TABLE+x+y*40,c);
        x++;

        jitter=random()&3;
        for(n=0;n<LETTERDELAY+jitter;n++)
        {
            waitVB();
            poke(CHAR_TABLE+x+y*40,blinkutes());
        }
        poke(CHAR_TABLE+x+y*40,0);
    }

    for(i=0;i<25;i++)
    {
        waitVB();
        mem_cpy((char *)0xd000,(char *)0xd000+40,40*24);
    }

}
